function [phi,psi,theta]=ANG(q)

   q = q./abs(q);
   
   a    =  q.w;
   b    =  q.x;
   c    =  q.y;
   d    =  q.z;
   
   R11  =  a.^2+b.^2-c.^2-d.^2;
   R13  =  2*(b.*d+a.*c);
   R22  =  a.^2-b.^2+c.^2-d.^2;
   R32  =  2*(c.*d+a.*b);
   R12  =  2*(b.*c-a.*d);
   R23  =  2*(c.*d-a.*b);
   R33  =  a.^2-b.^2-c.^2+d.^2;
   psi  =  asin(-R12)/2;

   ind2 = find(psi==abs(pi/4));
   
   if ~isempty(ind2)
         phi(ind2)   = atan2(-R23,R33)/2;
         theta(ind2) = 0;
   else
         phi      =  atan2(R32,R22)/2;
         theta    =  atan2(R13,R11)/2;
   end
   
   a1 = cos(phi).*cos(psi).*cos(theta)+sin(phi).*sin(psi).*sin(theta);
   ind1 = find(a1.*a<0);
   if ~isempty(ind1)
      ind2=find(phi(ind1)>=0);
      ind3=find(phi(ind1)<0);
      phi(ind1(ind2))  =  phi(ind1(ind2))-pi;
      phi(ind1(ind3))  =  phi(ind1(ind3))+pi;
   end
%      
%     
%     
%     ind1  =  min((exp(qi*phi).*exp(qk*psi).*exp(qj*theta)==(-1*q)),(phi>=0)); % Vetores com entradas binárias (true=1, false=0).
%  
%     ind1  =  find(ind1==1); % Retorna as posições com entrada igual a 1, colocando-as como índices.
%  
%     if ~isempty(ind1) % Se tais índices existirem, percorro o vetor phi atualizando-o exatamente nos valores correspondentes a esses índices.
%         phi(ind1)  =  phi(ind1)-pi;
%     end
%  
%     ind  =  min((exp(qi*phi).*exp(qk*psi).*exp(qj*theta)==(-1*q)),(phi<0)); % Vetores com entradas binárias (true=1, false=0).
%  
%     ind  =  find(ind==1); % Retorna as posições com entrada igual a 1, colocando-as como índices.
%  
%     if ~isempty(ind) % Se tais índices existirem, percorro o vetor phi atualizando-o exatamente nos valores correspondentes a esses índices.
%         phi(ind)  =  phi(ind)+pi;
%     end
end


